//*******************************************************
//       Copyright (c) 2003 Gena A. Petrov
//*******************************************************

unit QActionM;

interface

uses
  Classes, ComCtrls, QActnList, StdCtrls, ImgList;

type
  TActionListM = class(TActionList)
  public
    procedure AddAction(Action: TContainedAction);
    procedure RemoveAction(Action: TContainedAction);
  end;

  TActionM = class(TAction)
  private
    FMacrosOnExecute: String;
    procedure SetMacrosOnExecute(const S: String);
    procedure Macros_OnExecute(Sender: TObject);
  published
    property MacrosOnExecute: String read FMacrosOnExecute write SetMacrosOnExecute;
  end;

  procedure Register;

implementation

uses
  MacrosHandle;

procedure Register;
begin
  RegisterComponents('FormsConstructor',[TActionListM]);
  RegisterActions('MacrosAction',[TActionM],nil);
end;



procedure TActionListM.AddAction(Action: TContainedAction);
begin
  inherited;
end;

procedure TActionListM.RemoveAction(Action: TContainedAction);
begin
  inherited;
end;


procedure TActionM.SetMacrosOnExecute(const S: String);
begin
  if FMacrosOnExecute = S then exit;
  FMacrosOnExecute := S;
  if S <> '' then
    OnExecute := Macros_OnExecute
  else
    OnExecute:= nil;
end;

procedure TActionM.Macros_OnExecute(Sender: TObject);
begin
  if FMacrosOnExecute = '' then exit;
  try
    MacrosHandler.ExecMacros(FMacrosOnExecute);
  finally
  end;
end;

end.
